CREATE OR REPLACE PACKAGE "RANDOM"
is
/*
: 2.4.1  12.02.2005

:
                Oracle   
                

  :
           -      ;
           -      ;
           -        .
           
 :
           -     ;          
           -       ;
           -     ;
           -      .
           -         .

 :
              create table ARCHIV --     -  
                                 (NAME           VARCHAR2(30),
                                  PASS           VARCHAR2(30),
                                  HASH           VARCHAR2(16) not null);
              create table ARCHIV_ALL --     -  
                                 (NAME           VARCHAR2(30),
                                  PASS           VARCHAR2(30),
                                  HASH           VARCHAR2(16) not null);
              create table ARCHIV_SYS --     for SYS
                                 (NAME           VARCHAR2(3),
                                  PASS           VARCHAR2(30),
                                  HASH           VARCHAR2(16) not null);
              create table ARCHIV_SYSTEM --     for SYSTEM
                                 (NAME           VARCHAR2(6),
                                  PASS           VARCHAR2(30),
                                  HASH           VARCHAR2(16) not null);
              create table HOLD --  
                                 (NAME           VARCHAR2(30),
                                  PASS           VARCHAR2(30),
                                  HASH           VARCHAR2(16) not null);
              create table BRUTUS --     
                                 (PASS           VARCHAR2(30));
              create table NAMES  --    
                                 (PASS           VARCHAR2(30));
              create table DICT   --     
                                 (PASS           VARCHAR2(30));
              create table ERROR  --   
                                 (T_NAME         VARCHAR2(30),
                                  PASS           VARCHAR2(30))
              create table HPASS  --   
                                 (NAME           VARCHAR2(30),
                                  PASS           VARCHAR2(255),
                                  HASH           VARCHAR2(255),
                                  TOTAL_ATTEMPTS VARCHAR2(255),
                                  TIME           DATE default sysdate);

 :

create user PASS identified by ****;
grant connect to PASS;
grant unlimited tablespace to PASS; --    TABLESPACE's
--grant create session to PASS;
--grant create table to PASS;          
--grant create procedure to PASS;   

grant create user to PASS;
grant alter user to PASS;
grant drop user to PASS;
grant create trigger to PASS;        --      
                                     --    -     

grant select any dictionary to PASS;
grant select on SYS.V_$SESSION_LONGOPS to PASS; --    

         
UTL_FILE        UDUMP.

        
 MAILER.

 :

               
    MONITOR.       
 ,    .      
      ()   
    . 
               ,   
   BRUTUS     .   
 MONITOR      HPASS    .
             ( - )   
 HOLD (  100000 )         
.      ( - )    
  ARCHIV . 
              ARCHIV  ARCHIV_ALL,ARCHIV_SYS,
ARCHIV_SYSTEM.      ARCHIV_ALL,ARCHIV_SYS,
ARCHIV_SYSTEM.  ARCHIV       . 
   ARCHIV   ARCHIV_ALL,ARCHIV_SYS,ARCHIV_SYSTEM
            
    ARCCHIVER_ALL.   
         SYS and SYSTEM.
	       ARCHIV_ALL,ARCHIV_SYS,ARCHIV_SYSTEM      .
            
 . 
                .
      	      , 
        ,      .
         :
-     (  ARCHIV \ ARCHIV_...) - ;
-      ; ( )
-     BRUTUS - ;
-     NAMES - ;
-     DICT - ;
-      - ;
-      - ;
-         -  8  - .

      	    NAMES, DICT      2 
           
.

          :
-        ;
-    ;
-      DBMS_STATS;
-    ,      
     .

                
RANDOM.MONITOR (  - ST).
  
                 
   RANDOM.LOOK (  WHAT).
 
                 RANDOM.MONITOR  
   RANDOM.HASH_FIND(p_hash => <_>) 
    FIND (< >)


                 
      HOLD    
    

             :
-      SHARED .
-  PGA     32.  (pga_aggregate_target=33554432)
- sort_area_retained_size = 8M and more.
- shared_pool_size= 33554432  and more.
- db_cache_size=33554432 and more.
- db_file_multiblock_read_count=128.
- cursor_space_for_time = true  # Important

             
-    NOARCHIVELOG.
-       UNDO ( ) 
     REDO.
           
 UNDO     .    
  ARCHIV .

     ATHLON XP 1700 \ ATHLON 800
  512      7200rpm/min:
 - 600000 \ 400000    -    .
 - 5   \ 12     HOLD to ARCHIV
 - 20    ARCHIV_ALL  200  .
*/

--**************************************************************
--         
--      
--**************************************************************
   procedure monitor
--**************   *********************************
     (p_user    in varchar2 default 'NO_SEARCH_NAME', --     
      p_hash    in varchar2,               --    
      p_base    in varchar2 default 'NO_NAME_BASE',   --      
      p_time    in number default 10,      --   ,     
--**************   *************************
      p_archiv  in boolean default true,   --     
--**************    *************************
      p_brutus  in boolean default true,   --    
      p_names   in boolean default true,   --     
      p_dict    in boolean default true,   --     
      p_like    in varchar2 default '%',   --      
--**************     **************
      p_start   in number default 3,       --      3
      p_stan    in boolean default false,  --       (true)
      p_rand    in boolean default false,  --      (true)
      p_number  in boolean default false,  --    
      p_print   in boolean default false,  --     ,  
      
--**************  *************************
      p_to_arch in boolean default true,   --    
      p_trunc   in boolean default false,  --    HOLD   
      p_k_hpass in boolean default true,   --     HOLD and HPASS
      p_analiz  in boolean default false,  --  
      p_put     in boolean default true,   --   
      p_post    in boolean default false   --      
     ) ;

--**************************************************************
--         
--**************************************************************
   procedure analyzer
     (p_hash            in varchar2,       --    
      p_start           in number,         --      3
      p_time            in number,         --   ,     
      v_pass           out varchar2,       --   -   
      v_runtime        out varchar2,       --   -  
      v_total_attempts out varchar2        --   -     
     );
     
--********************************************************
--     HOLD
--********************************************************
   PROCEDURE HOLDER;
   PROCEDURE FIN_HOLDER;

--********************************************************
--    HOLD   ARCHIV
--********************************************************
   PROCEDURE ARCHIVER;

--********************************************************
--    ARCHIV   ARCHIV_ALL
--  ,    
--********************************************************
   PROCEDURE ARCHIVER_ALL;
   
--********************************************************
--      
--********************************************************
   PROCEDURE ERRORER;

--********************************************************
--    
--********************************************************
   procedure counter;

--**************************************************************************
--       6 
--**************************************************************************
   procedure long_ops
           (p_sofar     in number           --      
           );

--**************************************************************************
--      
--**************************************************************************
   procedure end_look;
   
--**************************************************************************
--      
--**************************************************************************
   procedure look;
   
--**************************************************************************
--       
--**************************************************************************
   function  find_hash(p_hash in varchar2) return varchar2;
   procedure hash_find(p_hash in varchar2);

-- **************************************************************
--   
-- **************************************************************
   PROCEDURE PUT_LINE(p_text in varchar2, kak in boolean default true);
 
   
--   pragma restrict_references(rand, WNDS);
--   pragma restrict_references(rand_max, WNDS);
--   pragma restrict_references(rand_pass, WNDS);
--   pragma restrict_references(random, WNDS, RNPS);

   end random;
/
